library(Seurat)
library(R.utils)

junction_reads = NULL
span_frags = NULL

junction_reads_dir = paste0(opt$fusiondir, "/", "junction")
span_reads_dir = paste0(opt$fusiondir, "/", "span")

if(dir.exists(junction_reads_dir)) {
	feature_file = paste0(junction_reads_dir, '/', 'features.tsv.gz')
	feature_file_size = file.size(gunzip(feature_file))
	barcodes_file = paste0(junction_reads_dir, '/', 'barcodes.tsv.gz')
	barcodes_file_size = file.size(gunzip(barcodes_file))
	feature_file_unzipped = paste0(junction_reads_dir, '/', 'features.tsv')
	barcodes_file_unzipped = paste0(junction_reads_dir, '/', 'barcodes.tsv')

	if((feature_file_size > 0) && (barcodes_file_size > 0)) {
		gzip(feature_file_unzipped)
		gzip(barcodes_file_unzipped)
		junction_reads = Read10X(junction_reads_dir)
	} else {
		junction_reads = NULL
	} 
}

if(dir.exists(span_reads_dir)) {
	feature_file = paste0(span_reads_dir, '/', 'features.tsv.gz')
	feature_file_size = file.size(gunzip(feature_file))
	barcodes_file = paste0(span_reads_dir, '/', 'barcodes.tsv.gz')
	barcodes_file_size = file.size(gunzip(barcodes_file))
	feature_file_unzipped = paste0(span_reads_dir, '/', 'features.tsv')
	barcodes_file_unzipped = paste0(span_reads_dir, '/', 'barcodes.tsv')

	if((feature_file_size > 0) && (barcodes_file_size > 0)) {
		gzip(feature_file_unzipped)
		gzip(barcodes_file_unzipped)
		span_frags = Read10X(span_reads_dir)
	} else {
		span_frags = NULL
	} 
}
