conda_env_path = "${params.cogent_root}" + '/config/env/bowtie2.yaml'

process BOWTIE2_ALIGN {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        tuple val(sample_id), path(reads), path(bowtie2_index)

    output:
        tuple val(sample_id), path('bowtie2_align_bams/*_bowtie2.bam'), emit: bam
        tuple val(sample_id), path('logs/bowtie2_align/*_bowtie2.log'), emit: log_file

    script:

        def read1 = "${reads[0]}"
        def read2 = "${reads[1]}"
        """
        mkdir -p bowtie2_align_bams
        mkdir -p logs/bowtie2_align

        (bowtie2 \\
        -x ${bowtie2_index}/genome \\
        -1 $read1 \\
        -2 $read2 \\
        -p ${task.cpus} \\
        | samtools view -@ ${task.cpus} -Sb -o bowtie2_align_bams/${sample_id}_bowtie2.bam \\
        ) 2>&1 | tee logs/bowtie2_align/${sample_id}_bowtie2.log
        """
}
