conda_env_path = "${params.cogent_root}" + '/config/env/bowtie2.yaml'

process BOWTIE2_INDEX {
    conda conda_env_path
    storeDir "${params.genome_dir}"

    input:
        path genome_fasta

    output:
        path("${params.genome_name}/bowtie2_index")

    script:
        """
        mkdir -p ${params.genome_name}/bowtie2_index
        bowtie2-build --threads ${task.cpus} ${genome_fasta} ${params.genome_name}/bowtie2_index/genome
        """

}
