conda_env_path = "${params.cogent_root}" + '/config/env/demux_env.yaml'
clean_counts_script = "${params.cogent_root}" + '/lib/dna_analyze/clean_counts.py'

process CLEAN_COUNTS {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        path(counts_table)

    output:
        path("coverage/countsTable.txt"), emit: clean_counts

    script:

        """ 
        mkdir -p coverage
        
        python ${clean_counts_script} \\
        --counts ${counts_table} \\
        --cleaned coverage/countsTable.txt
        """
}
