conda_env_path = "${params.cogent_root}" + '/config/env/deeptools.yaml'

process CORRELATION {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        path(read_counts)
        each correlation_type

    output:
        path("correlation/*_heatmap_sampleCorr_noOutliers.pdf"), emit: correlation_heatmap_no
        path("correlation/*_matrix_noOutliers.txt"), emit: matrix_no

    script:

        def title = "Sample ${correlation_type} correlation"
        """ 
        mkdir -p correlation
        
        plotCorrelation \\
        --corData ${read_counts} \\
        --corMethod ${correlation_type} \\
        --plotTitle "${title}" \\
        --skipZeros \\
        --whatToPlot heatmap \\
        --plotFile correlation/${correlation_type}_heatmap_sampleCorr_noOutliers.pdf \\
        --outFileCorMatrix correlation/${correlation_type}_matrix_noOutliers.txt \\
        --removeOutliers \\
        --plotNumbers

        """
}
