nextflow.enable.dsl=2

conda_env_path = "${params.cogent_root}" + '/config/env/fastqc.yaml'
fastqc_script = "${params.cogent_root}" + '/bin/fastqc.sh'
if (params.type_of_experiment == "shasta_total_rna" && params.keep_intermediate ){
    publishdir_enabled = true
} else if (params.type_of_experiment == "shasta_total_rna" && !params.keep_intermediate ) {
    publishdir_enabled = false
} else {
    publishdir_enabled = true
}

process FASTQC_TRIM {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy', enabled: publishdir_enabled

    input:
        tuple val(sample_id), path(reads)

    output:
        tuple val(sample_id), path ("fastqc_post_trim/*.zip"), emit: fastqc_zip
        tuple val(sample_id), path ("fastqc_post_trim/*.html"), emit: fastqc_html

    script:

        def read1 = "${reads[0]}"
        def read2 = "${reads[1]}"
        """
        bash ${fastqc_script} "fastqc_post_trim" "$read1" "$read2"
        """
}
