
conda_env_path = "${params.cogent_root}" + '/config/env/cogentds_report.yaml'
finalize_seurat_obj_script = "${params.cogent_root}" + '/lib/salmon/finalize_seurat_objects.R'

process FINALIZE_SEURAT_OBJECTS {
    conda conda_env_path

    input:
        path (exon_plus_intron_rds)
        path (isoform_rds)
        path (exon_rds)
        path (mito_genes)
        path (gene_map_file)
        val (umi_only)

    output:
        path("CogentAP_gene_and_isoform_counts*.rds"), emit: final_counts_rds
        path("barcode_stats*.csv"), emit: barcode_stats_file


    script:

        def rename_stats = umi_only ? "mv barcode_stats.csv barcode_stats_umis.csv" : ""

        """
        Rscript ${finalize_seurat_obj_script} . ${gene_map_file} ${mito_genes} ${params.gene_count_threshold}

        ${rename_stats}

        """
}
