ginko_exec_path = "${params.cogent_root}" + "/lib/ginkgo"

process GINKGO_BINUNSORTED {

    input:
        tuple val(sample_id), path(bed_file), path(ginkgo_ref)
        val(bin_size_actual)
        val(read_length_actual)

    output:
        path("ginkgo_binunsorted/${sample_id}_mapped"), emit: mapped

    shell:

        def bin_file = "variable_${bin_size_actual}_${read_length_actual}_bowtie"

        """
        mkdir -p ginkgo_binunsorted

        NUMBER_OF_BINS=`wc -l < ${ginkgo_ref}/${bin_file}`
        
        ${ginko_exec_path}/scripts/binUnsorted ${ginkgo_ref}/${bin_file} \$NUMBER_OF_BINS ${bed_file} ${sample_id} ${sample_id}_mapped

        mv ${sample_id}_mapped ginkgo_binunsorted/.
        """
}
