conda_env_path = "${params.cogent_root}" + '/config/env/ginkgo_r.yaml'
ginkgo_exec_path = "${params.cogent_root}" + "/lib/ginkgo/"

process GINKGO_PROCESS {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: "copy"

    input:
        path (data)
        path (ginkgo_ref)
        val (bin_size_actual)
        val (read_length_actual)

    output:
        path("ginkgo_output/SegBreaks"), emit: seg_breaks
        path("ginkgo_output/SegCopy"), emit: seg_copy
        path("ginkgo_output/SegFixed"), emit: seg_fixed
        path("ginkgo_output/SegNorm"), emit: seg_norm
        path("ginkgo_output/SegStats"), emit: seg_stats

    shell:
        def bin_file = "variable_${bin_size_actual}_${read_length_actual}_bowtie"
        """
        touch refDummy.bed_mapped
        touch ploidyDummy.txt
        mkdir -p ginkgo_output

        Rscript ${ginkgo_exec_path}/scripts/process.R ${ginkgo_ref} . *statfile* ${data} \
            ${params.segmentation_method} ${bin_file} ${params.cluster_method} \
            ${params.distance_method} ${params.color_scheme} refDummy.bed_mapped \
            ${params.facs_file_provided} ploidyDummy.txt \
            ${params.include_sex_chromosomes} ${params.mask_bad_bins}

        mv Seg* ginkgo_output/. 
        
        """
}
