conda_env_path = "${params.cogent_root}" + '/config/env/multiqc.yaml'

process MULTIQC_REPORT {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        path ('fastqc_pre_trim/')
        path ('logs/trimmomatic/')
        path ('fastqc_post_trim/')
        path ('logs/bowtie2_align/*')
        path ('logs/picard_sortsam/*')
        path ('logs/picard_dssort/*')
        path ('logs/picard_markduplicates/*.log')
        path ('picard_markduplicates/*.txt')
        path ('logs/picard_dsmarkduplicates/*.log')
        path ('picard_dsmarkduplicates/*.txt')
        path ('picard_insertmetrics/*')
        path ('correlation/*.pdf')
        path ('correlation/*matrix_noOutliers.txt')

    output:
        path "multiqc_report/*.html", emit:report
        path "multiqc_report/*_data", emit:data
        path "multiqc_report/*_plots", optional:true, emit: plots

    script:

        """ 
        mkdir -p multiqc_report

        multiqc \\
            -n multiqc_report/multiqc_report.html \\
            -f \\
            \$PWD \\
            fastqc_pre_trim/*.zip \\
            fastqc_post_trim/*.zip
         """
}