conda_env_path = "${params.cogent_root}" + '/config/env/picard.yaml'

process PICARD_DSSORT {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        tuple val(sample_id), path(sam)

    output:
        tuple val(sample_id), path('picard_dssorted_bams/*_bowtie2_sorted.bam'), emit: sorted_bam
        tuple val(sample_id), path('picard_dssorted_bams/*_bowtie2_sorted.bai'), emit: sorted_bam_index
        tuple val(sample_id), path('logs/picard_dssort/*_downsampleSort.log'), emit: log_file

    script:

        """ 
        mkdir -p picard_dssorted_bams
        mkdir -p logs/picard_dssort
        
        (picard -Xmx${task.memory.toMega()}M SortSam \\
        INPUT=${sam} \\
        OUTPUT=picard_dssorted_bams/${sample_id}_bowtie2_sorted.bam \\
        SORT_ORDER=${params.sortorder} \\
        CREATE_INDEX=${params.createindex} \\
        TMP_DIR=${sample_id}.tmp \\
        ) 2>&1 | tee logs/picard_dssort/${sample_id}_downsampleSort.log

        rm -rf ${sample_id}.tmp
        """
}
