
conda_env_path = "${params.cogent_root}" + '/config/env/picard.yaml'

process PICARD_INSERTMETRICS {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        tuple val(sample_id), path(bam)

    output:
        tuple val(sample_id), path('picard_insertmetrics/*_insert_size_metrics.txt'), emit: insert_metrics
        tuple val(sample_id), path('picard_insertmetrics/*_insert_size_histogram.pdf'), emit: insert_histogram
        tuple val(sample_id), path('logs/picard_insertmetrics/*_ins_metrics.log'), emit: log

    script:

        """ 
        mkdir -p picard_insertmetrics
        mkdir -p logs/picard_insertmetrics
        
        (picard -Xmx${task.memory.toMega()}M CollectInsertSizeMetrics \\
        I=${bam} \\
        O=picard_insertmetrics/${sample_id}_insert_size_metrics.txt \\
        HISTOGRAM_FILE=picard_insertmetrics/${sample_id}_insert_size_histogram.pdf \\
        ASSUME_SORTED=${params.assumesorted} \\
        TMP_DIR=${sample_id}_tmp.log \\
        ) 2>&1 | tee logs/picard_insertmetrics/${sample_id}_ins_metrics.log 

        rm -rf ${sample_id}_tmp.log

        """
}
