conda_env_path = "${params.cogent_root}" + '/config/env/picard.yaml'

process PICARD_SORTSAM {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        tuple val(sample_id), path(sam)

    output:
        tuple val(sample_id), path('picard_sorted_bams/*_bowtie2_sorted.bam'), emit: sorted_bam
        tuple val(sample_id), path('logs/picard_sortsam/*_allSorted.log'), emit: log_file

    script:

        """ 
        mkdir -p picard_sorted_bams
        mkdir -p logs/picard_sortsam 
        
        (picard -Xmx${task.memory.toMega()}M SortSam \\
        INPUT=${sam} \\
        OUTPUT=picard_sorted_bams/${sample_id}_bowtie2_sorted.bam \\
        SORT_ORDER=${params.sortorder} \\
        TMP_DIR=${sample_id}.all.tmp \\
        ) 2>&1 | tee logs/picard_sortsam/${sample_id}_allSorted.log
        rm -rf ${sample_id}.all.tmp
        """
}
