preprocess_summary_files_script = "${params.cogent_root}" + '/lib/add_genome/preprocess_summary_files.R'
conda_env_path = "${params.cogent_root}" + '/config/env/cogentds_report.yaml'

process PREPROCESS_SUMMARY_FILES {
    conda conda_env_path
    storeDir "${params.genome_dir}"

    input:
        path (gene_transcript_map)
        path (gene_info_file)

    output:
        path("${params.genome_name}/gene_biotype_and_length_info.txt"), emit: gene_biotype_file
        path("${params.genome_name}/gene_transcript_map_with_genename.txt"), emit: gene_map_with_genename

    script:
        """
        Rscript ${preprocess_summary_files_script} ${gene_transcript_map} ${gene_info_file} ${params.genome_name}
        """
}
