
conda_env_path = "${params.cogent_root}" + '/config/env/cogentds_report.yaml'
process_exon_intron_script = "${params.cogent_root}" + '/lib/salmon/process_salmon_exon_intron.R'

process PROCESS_EXON_INTRON {
    conda conda_env_path
    publishDir = [
        [
            path: { "${params.output_dir}" },
            mode: 'move',
            pattern: "gene_and_transcript_info/*.csv",
        ]
    ]

    input:
        path (quants_files)
        path (header_files)
        path (gene_transcript_map)
        path (gene_biotype_file)
        path (transcript_info_file) 
        path (gene_info_file)    

    output:
        path("CogentAP_seuratObject_gene_Exon_plus_Intron.rds"), emit: exon_plus_intron_rds
        path("gene_and_transcript_info/*.csv"), emit: gene_and_transcript_info

    script:

        """
        mkdir -p gene_and_transcript_info
        Rscript ${process_exon_intron_script} . ${gene_transcript_map} ${gene_biotype_file} ${transcript_info_file} .

        cp ${gene_info_file} gene_and_transcript_info/.
        cp ${transcript_info_file} gene_and_transcript_info/.

        """
}
