
conda_env_path = "${params.cogent_root}" + '/config/env/cogentds_report.yaml'
process_exon_isoforms_script = "${params.cogent_root}" + '/lib/salmon/process_salmon_exon_isoforms.R'

process PROCESS_EXON_ISOFORMS {
    conda conda_env_path

    input:
        path (quants_files)
        path (header_files)
        path (gene_transcript_map)
        path (gene_info_file)
        path (transcript_info_file)        

    output:
        path("CogentAP_seuratObject_isoforms_Only.rds"), emit: isoform_rds
        path("CogentAP_seuratObject_gene_Exon_Only.rds"), emit: exon_rds

    script:

        """
        Rscript ${process_exon_isoforms_script} . ${gene_transcript_map} ${gene_info_file} ${transcript_info_file} .
        """
}
