conda_env_path = "${params.cogent_root}" + '/config/env/bowtie2.yaml'

process SAMTOOLS_BAMTOBED {
  conda conda_env_path
  publishDir "${params.output_dir}", mode: "copy"

  input:
  tuple val(sample_id), path(bam)

  output:
  tuple val(sample_id), path("samtools_bamtobed/*.bed"), emit: bed

  shell:
  """
  mkdir -p samtools_bamtobed
  samtools view -b -q20 ${bam} | bamToBed > samtools_bamtobed/${sample_id}.bed
  """
}
