conda_env_path = "${params.cogent_root}" + '/config/env/bowtie2.yaml'

process SAMTOOLS_DOWNSAMPLE {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        tuple val(sample_id), path(sam)

    output:
        tuple val(sample_id), path('samtools_down_sam/*_bowtie2.sam'), emit: mapped_sam

    script:

        def final_num_reads = 1000000 * 2

        """ 
        mkdir -p samtools_down_sam
        
        cat <(samtools view -@ ${task.cpus} -SH ${sam}) \\
        <(samtools view -@ ${task.cpus} -S ${sam} | shuf -n ${final_num_reads}) \\
        > samtools_down_sam/${sample_id}_1M_bowtie2.sam


        """
}
