conda_env_path = "${params.cogent_root}" + '/config/env/bowtie2.yaml'

process SAMTOOLS_FILTERUNMAPPED {
    conda conda_env_path
    publishDir "${params.output_dir}", mode: 'copy'

    input:
        tuple val(sample_id), path(bam)

    output:
        tuple val(sample_id), path('samtools_mapped_sam/*_bowtie2_mapped.sam'), emit: mapped_sam

    script:

        """ 
        mkdir -p samtools_mapped_sam
        
        samtools view \\
        -@ ${task.cpus} \\
        -h \\
        -F 4 \\
        ${bam} > samtools_mapped_sam/${sample_id}_bowtie2_mapped.sam

        """
}
